/*
 * CampaignlistCtrl
 *
 * responsible for displaying side navi
 * view : list.html
 */
(function() {
    'use strict';

    angular
        .module('starter')
        .controller('CampaignlistCtrl', CampaignlistCtrl);

    function CampaignlistCtrl($scope,$rootScope,$state,$timeout,$ionicPlatform,config,apiRequesterService,Flash, headerTitleService, $ionicHistory, $ionicPopup) {

        var limit  = 5;
        var page   = 0;
        var offset = 0;
        var type = 'campaign';
        var initial_load = false;
        $scope.noMoreItemsAvailable = false;
        $scope.items = [];

        $scope.refreshing = false;

        $scope.doRefresh = function() {
            $scope.refreshing = true;
            getCampaigns();
        }

        $scope.loadMore = function() {
            if (!$scope.noMoreItemsAvailable) {
                getCampaigns(true);
            }
        }

        function getCampaigns(options) {
            if (!initial_load) {
                initial_load = true;
                let global_limit = limit ;
                let global_offset = offset ;
                if (options == null) {
                  global_limit = limit;
                  global_offset = 0;
                  $scope.noCampaigns = true;
                }
                apiRequesterService.checkConnection().then(function(res){
                    $scope.noMoreItemsAvailable = true;
                    apiRequesterService.getBanners(type, global_limit, global_offset).then(function(res) {
                        if (res.data.length!==0) {
                            $scope.noCampaigns = false;
                            angular.forEach(res.data, function(value, key){
                                $rootScope.CampaignItems[value.Banner.id] = {
                                    id : value.Banner.id,
                                    news_id : value.Banner.news_id,
                                    url: value.Banner.url,
                                    title: value.Banner.title1 + value.Banner.title2,
                                    image: config.imageServer + '/images/banners/' + value.Banner.image_sp,
                                    is_login_user: value.Banner.is_login_user,
                                    is_survey: value.Banner.is_survey,
                                    sort_order_campaign: parseInt(value.Banner.sort_order_campaign)
                                };
                            });
                            $scope.items = $rootScope.CampaignItems;
                            if (options != null) {
                                offset += limit;
                            }
                            $scope.noMoreItemsAvailable = false;
                        } else {
                            $scope.noMoreItemsAvailable = true;

                            if (offset == 0) {
                                $scope.noCampaigns = true;
                            }
                        }
                    },function(err){
                        $scope.noMoreItemsAvailable = true;
                    }).finally(function() {
                        initial_load = false;
                        // Stop the loading from spinning
                        $scope.$broadcast('scroll.infiniteScrollComplete');
                        $scope.$broadcast('scroll.refreshComplete');
                        $timeout(function(){
                            $scope.refreshing = false;
                        },1500);
                    });
                },function(err){
                    $scope.err = false;
                    $scope.errors = undefined;
                    $rootScope.connected = 'noConnection';
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    $scope.$broadcast('scroll.refreshComplete');
                });
            }

        }

        $scope.goToDetail = function(item) {
          if (item.url != null && item.url != '') {
              $rootScope.parameter = item.url;
              headerTitleService.setHeaderName('キャンペーン詳細');
              showPopup();
          } else if (item.url == null && item.news_id == null && item.is_survey == 1) {
              $ionicHistory.nextViewOptions({
                  disableAnimate: true
              });
              $state.go('surveys');
          } else {
            apiRequesterService.checkConnection().then(function(res) {
                apiRequesterService.getNews(1, 1, 1, item.news_id).then(function(res) {
                    headerTitleService.setHeaderName('ニュース詳細');
                    $rootScope.News = res.data.News;
                    $rootScope.News.start_dt = res.data.News.start_dt.split(' ')[0];
                    $state.go('news-detail', {'id':res.data.News.id});
                    if ($rootScope.News.url1 != null && $rootScope.News.url1 != '') {
                        $rootScope.parameter = $rootScope.News.url1;
                        if ($state.current.url == '/home') {
                          $rootScope.belong_page = 'home';
                        } else {
                          $rootScope.belong_page = 'news';
                        }
                        headerTitleService.setHeaderName('ニュース詳細');
                        showPopup();
                    } else {
                        $state.go('news-detail', {'id':res.data.News.id});
                    }
                }, function(err) {
                    $scope.err = true;
                    $scope.errors = err;
                });
            },function(res){
                $scope.err = false;
                $scope.errors = undefined;
                $rootScope.connected = 'noConnection';
            });
          }
        }

        $ionicPlatform.on('resume', onResume);

        function onResume() {
            page = 0;
            $scope.doRefresh();
        }

        $scope.$on('$stateChangeSuccess', function() {
            // reset after login / logout
            $scope.customer = $rootScope.Customer;

            if ($rootScope.CampaignItems == null) {
                $rootScope.CampaignItems = [];
                $scope.items = $rootScope.CampaignItems;
            } else {
                $scope.items = $rootScope.CampaignItems
                $scope.show_now = true
            }
        });

        function showPopup() {
            var target = '_system';
            if (config.isAndroid) {
                target = '_self'
            }
            var confirmPopup = $ionicPopup.confirm({
              title: 'ブラウザで開く',
              template: 'このページはアプリでは開けないため、ブラウザが起動しますがよろしいですか？',

              buttons: [{
                    text: 'いいえ',
                    type: 'button-disable'
                  },{
                    text: 'はい',
                    type: 'button-positive',
                    onTap: function(e) {
                      window.open($rootScope.parameter, target, 'location=yes')
                    }
                  }
                ]
            });
        }

      }
})();
