/*
 * DeactivateCtrl
 *
 * responsible for deactivating customer account
 * view : deactivate.html
 */
(function() {
    'use strict';

    angular
        .module('starter')
        .controller('DeactivateCtrl', DeactivateCtrl);

    function DeactivateCtrl($scope, $log, $rootScope, $state, $ionicLoading, apiRequesterService, errorFactory, Flash, DbFactory, $timeout) {
        $scope.saving = false;

        $scope.deactivate = function() {
            $scope.saving = true;
            $ionicLoading.show();
            apiRequesterService.deactivate($rootScope.Auth, $rootScope.Customer).then(function(res) {
                $scope.saving = false;
                var message = 'ご利用ありがとうございました。';
                Flash.create('success', message);
                $ionicLoading.hide();
                DbFactory.drop('customer').then(function() {
                    DbFactory.drop('auth_customer').then(function() {
                        $rootScope.Customer = null;
                        $rootScope.Auth = null;
                        $rootScope.OrderItems = [];
                        $rootScope.PointItems = [];
                        $state.go('login');
                        $timeout(function(){
                            $rootScope.visit_home = null;
                        },1000);
                    });
                });
            }, function(err){
                // error
                Flash.dismiss();
                $scope.saving = false;
                $ionicLoading.hide();
            });
        }
    }
})();
