/*
 * bannerCtrl
 *
 * responsible for displaying Calendar in home screen
 * view : banner.html
 */
(function() {
    'use strict';

    angular
        .module('starter')
        .controller('bannerCtrl', bannerCtrl);

    function bannerCtrl($scope, $rootScope, $state, $timeout,$ionicLoading, apiRequesterService, config, $ionicHistory, $ionicSlideBoxDelegate, headerTitleService, $ionicPopup){

        $scope.customer = $rootScope.Customer;
        setTimeout(function(){
            $ionicSlideBoxDelegate.update();
        },5000);

        $scope.updateSlideIndex = function(index) {
            if (($ionicSlideBoxDelegate.$getByHandle('banner-slider').count() - 1) == index) {
                $timeout(function() {
                    $ionicSlideBoxDelegate.$getByHandle('banner-slider').slide(0);
                }, 5000);
            }
        };

        $scope.goToDetail = function(banner) {
          if (banner.url != null && banner.url != '') {
              $rootScope.parameter = banner.url;
              headerTitleService.setHeaderName('キャンペーン詳細');
              showPopup();
          } else if (banner.url == null && banner.news_id == null && banner.is_survey == 1) {
              $ionicHistory.nextViewOptions({
                  disableAnimate: true
              });
              $state.go('surveys');
          } else {
            apiRequesterService.checkConnection().then(function(res) {
                apiRequesterService.getNews(1, 1, 1, banner.news_id).then(function(res) {
                    headerTitleService.setHeaderName('ニュース詳細');
                    $rootScope.News = res.data.News;
                    $rootScope.News.start_dt = res.data.News.start_dt.split(' ')[0];
                    if ($rootScope.News.url1 != null && $rootScope.News.url1 != '') {
                        $rootScope.parameter = $rootScope.News.url1;
                        if ($state.current.url == '/home') {
                          $rootScope.belong_page = 'home';
                        } else {
                          $rootScope.belong_page = 'news';
                        }
                        headerTitleService.setHeaderName('ニュース詳細');
                        showPopup();
                    } else {
                        $state.go('news-detail', {'id':res.data.News.id});
                    }
                }, function(err) {
                    $scope.err = true;
                    $scope.errors = err;
                });
            },function(res){
                $scope.err = false;
                $scope.errors = undefined;
                $rootScope.connected = 'noConnection';
            });
          }
        }

        $scope.handlePagerClick = function(index) {
            $ionicSlideBoxDelegate.slide(index);
        }

        $scope.$on('updateSlider', function() {
            $ionicSlideBoxDelegate.$getByHandle('banner-slider').update();
        });

        function showPopup() {
          var target = '_system';
            if (config.isAndroid) {
                target = '_self'
            }
            var confirmPopup = $ionicPopup.confirm({
              title: 'ブラウザで開く',
              template: 'このページはアプリでは開けないため、ブラウザが起動しますがよろしいですか？',

              buttons: [{
                    text: 'いいえ',
                    type: 'button-disable'
                  },{
                    text: 'はい',
                    type: 'button-positive',
                    onTap: function(e) {
                      window.open($rootScope.parameter, target, 'location=yes')
                    }
                  }
                ]
            });
        }
    }

})();