/*
 * MyPageCtrl
 *
 * responsible for displaying customer points
 * view : mypage.html
 */
(function() {
    'use strict';

    angular
        .module('starter')
        .controller('MyPageCtrl', MyPageCtrl);

    function MyPageCtrl($scope, $state, $rootScope, $ionicSlideBoxDelegate, apiRequesterService, DbFactory, $ionicLoading, $ionicPlatform) {

        $scope.doRefresh = function() {
            apiRequesterService.getInfo($rootScope.Auth.customer_id, $rootScope.Auth.access_token).then(function(res) {
                $rootScope.Customer = '';
                $rootScope.Customer = res.data.Customer;
                DbFactory.drop('customer').then(function() {
                    DbFactory.insert('customer', [$rootScope.Customer]);
                    $scope.Customer = $rootScope.Customer;
                    $scope.Customer.total_points = parseInt($scope.Customer.current_charge_point) + parseInt($scope.Customer.current_bonus_point);
                });
                $scope.$broadcast('scroll.refreshComplete');
            });
        }

        $scope.Customer = $rootScope.Customer;
        $scope.Customer.total_points = parseInt($scope.Customer.current_charge_point) + parseInt($scope.Customer.current_bonus_point);

        $scope.bc = {
            format: 'CODE128',
            lineColor: '#000000',
            width: 3,
            height: 110,
            displayValue: false,
            background: '#ffffff',
            margin: 0,
            marginTop: undefined,
            marginBottom: undefined,
            marginLeft: undefined,
            marginRight: undefined,
            valid: function (valid) {
            }
        }

        apiRequesterService.checkConnection();
    }
})();
