/*
 * InfoCtrl
 *
 * responsible for displaying Info screen
 * view : info.html
 */
(function() {
    'use strict';

    angular
        .module('starter')
        .controller('InfoCtrl', InfoCtrl);

    function InfoCtrl($scope, $log, $state, $rootScope, $timeout, apiRequesterService, errorFactory, DbFactory) {
        $rootScope.Customer.pref_name = $rootScope.Customer.pref_name == null ? '' : $rootScope.Customer.pref_name;
        $rootScope.Customer.city = $rootScope.Customer.city == null ? '' : $rootScope.Customer.city;
        $rootScope.Customer.street = $rootScope.Customer.street == null ? '' : $rootScope.Customer.street;
        $scope.Customer.address = $rootScope.Customer.pref_name+$rootScope.Customer.city+$rootScope.Customer.street;
        // $scope.mail_flg = $scope.Customer.mail_flg == "1" ? true : false;

        if ($scope.Customer.address == '')  {
            $scope.Customer.address = '未登録';
        }

        $scope.$on('$ionicView.enter', function(event) {
            if (event.targetScope === $scope) {
                apiRequesterService.getInfo($rootScope.Customer.customer_id, $rootScope.Auth.access_token).then(function(res) {
                    var res_mailflg   = res.data.Customer.mail_flg == "1" ? true : false;

                    if (res.data.Customer.email != $rootScope.Customer.email) {
                        $rootScope.Customer.email = "";
                        $rootScope.Customer.email = res.data.Customer.email;
                    }
                    if (res_mailflg != $rootScope.Customer.mailflg) {
                        $rootScope.Customer.mailflg = "";
                        $rootScope.Customer.mailflg = res.data.Customer.mailflg;
                    }

                    $rootScope.Customer=res.data.Customer;
                    DbFactory.drop('customer').then(function() {
                        // save customer data to local
                        var customerData = [$rootScope.Customer];
                        DbFactory.insert('customer', customerData);
                    });
                    $scope.Customer = $rootScope.Customer;
                    $rootScope.Customer.pref_name = $rootScope.Customer.pref_name == null ? '' : $rootScope.Customer.pref_name;
                    $rootScope.Customer.city = $rootScope.Customer.city == null ? '' : $rootScope.Customer.city;
                    $rootScope.Customer.street = $rootScope.Customer.street == null ? '' : $rootScope.Customer.street;
                    $scope.Customer.address = $rootScope.Customer.pref_name+$rootScope.Customer.city+$rootScope.Customer.street;
                    $scope.Customer.mailflg   = $scope.Customer.mailflg == "1" ? true : false;
                    if ($scope.Customer.address == '')  {
                        $scope.Customer.address = '未設定';
                    }
                    $scope.mail_flg = res_mailflg;
                }, function(err){
                    if (err == 'TokenExpired') {
                        errorFactory.logoutErrorHandling();
                    }
                });
            }
        });

        $scope.loadCustomer = function() {
            $scope.customer = $rootScope.Customer;
            $scope.customer.mailflg   = $scope.customer.mailflg == "1" ? true : false;
        }

        $scope.toggleMail = function($event) {
            $rootScope.Customer.mailflg = $event;
            $scope.Customer.mailflg = $event;
            apiRequesterService.updateEmailFlg( $rootScope.Auth , $rootScope.Customer ).then(function(res){
                // success
            }, function(err){
                if (err == 'TokenExpired') {
                    errorFactory.logoutErrorHandling();
                }
            });
        }

        $scope.customer_email = function() {
            $state.go("change-email");
        }

        $scope.new_pass = function() {
            $state.go("newpass");
        }
    }

})();
