/*
 * LoginCtrl
 *
 * responsible for login
 * view : login.html
 */
(function() {
    'use strict';

    angular
        .module('starter')
        .controller('LoginCtrl', LoginCtrl);

    function LoginCtrl($scope, $log, $state, $rootScope, $ionicLoading, $ionicHistory, config, apiRequesterService, DbFactory, $ionicModal, $moment, $ionicPopup, $window) {
        $scope.saving = false;
        $rootScope.logged_in = false;

        // setTimeout(function() {
        //     if(typeof(FCMPlugin) !== "undefined"){
        //         FCMPlugin.onNotification(
        //             function(data){
        //                 if (data.wasTapped) {
        //                     //Notification was received on device tray and tapped by the user.
        //                     // alert( JSON.stringify(data) );
        //                 } else {
        //                     //Notification was received in foreground. Maybe the user needs to be notified.
        //                     // alert( JSON.stringify(data) );
        //                 }
        //             },
        //             function(msg){
        //                 $log.debug('onNotification callback successfully registered: ' + msg);
        //             },
        //             function(err){
        //                 $log.debug('Error registering onNotification callback: ' + err);
        //             }
        //         );
        //     }
        // }, 10000);

        $scope.data = {};

        function checkLatestOrder() {
            var latest_order = null
            var review_flag = null;
            var registered_business_date_unix;
            apiRequesterService.getOrders($rootScope.Customer.customer_id,$rootScope.Auth, 1, 0, true).then(function(res) {
                if (res.data.length !== 0) {
                    registered_business_date_unix = $moment(res.data[0].Order.registered_business_date).unix();
                    angular.forEach(res.data, function(value, key){
                        review_flag = typeof value.Order.Review != 'undefined' ?  true : null;
                        latest_order = {
                            id: value.Order.id,
                            order_detail_id: value.Order.OrderDetail.id,
                            customer_id: $rootScope.Customer.customer_id,
                            stars: review_flag
                        };
                    });
                    angular.forEach(res.data, function(value, key){
                        review_flag = typeof value.Order.Review != 'undefined' ?  true : null;
                        $rootScope.order = {
                            registerd_business_date: value.Order.registered_business_date,
                            order_detail_id: value.Order.OrderDetail.id,
                            customer_id: $rootScope.Customer.customer_id,
                            product_names : value.Order.product_names,
                            total_sub_total : value.Order.total_sub_total,
                            total_amount_of_price : value.Order.total_amount_of_price,
                            shop_name: value.Order.shop_name,
                            therapist_name: $scope.mySplit(value.Order.OrderDetail.TherapistNomination.therapist_name, 0),
                            treated_body_parts: value.Order.TreatedBodyPart ,
                            treated_body_head: parseInt(value.Order.TreatedBodyPart.strength_of_front_head) + parseInt(value.Order.TreatedBodyPart.strength_of_back_head) + parseInt(value.Order.TreatedBodyPart.strength_of_side_of_head),
                            treated_body_shoulder: parseInt(value.Order.TreatedBodyPart.strength_of_left_shoulder) + parseInt(value.Order.TreatedBodyPart.strength_of_right_shoulder),
                            treated_body_arm: parseInt(value.Order.TreatedBodyPart.strength_of_left_arm) + parseInt(value.Order.TreatedBodyPart.strength_of_right_arm),
                            treated_body_waist: parseInt(value.Order.TreatedBodyPart.strength_of_left_waist) + parseInt(value.Order.TreatedBodyPart.strength_of_right_waist),
                            treated_body_thigh: parseInt(value.Order.TreatedBodyPart.strength_of_left_thigh) + parseInt(value.Order.TreatedBodyPart.strength_of_right_thigh),
                            treated_body_calf: parseInt(value.Order.TreatedBodyPart.strength_of_left_calf) + parseInt(value.Order.TreatedBodyPart.strength_of_right_calf),
                            treated_body_foot: parseInt(value.Order.TreatedBodyPart.strength_of_left_foot) + parseInt(value.Order.TreatedBodyPart.strength_of_right_foot)
                        };
                    });
                }
                // if there is order
                if (latest_order != null && res.data[0].Order.original_order_id == null) { // order must be updated if original_order_id is set
                    // Check if latest_order_detail_id is exist in local
                    DbFactory.tableExist('latest_order_detail_id').then(function() {
                        // exist
                        DbFactory.get('latest_order_detail_id').then(function(data) {
                            $rootScope.LatestOrder = data[0];
                            // if LatestOrder is same as in local DB
                            if ($rootScope.LatestOrder.order_detail_id == latest_order.order_detail_id && $rootScope.LatestOrder.customer_id == $rootScope.Customer.customer_id ) {
                                changeState();
                            } else {
                                // insert if not yet review
                                if (review_flag == null) {
                                    // remove and add latest_order_detail_id
                                    DbFactory.drop('latest_order_detail_id').then(function() {
                                        var objOrder = [latest_order];
                                        DbFactory.insert('latest_order_detail_id', objOrder);
                                        DbFactory.get('latest_order_detail_id').then(function(data) {
                                            $rootScope.LatestOrder = data[0];
                                        });
                                    });
                                    if (registered_business_date_unix > $moment().subtract(1, 'Month').unix()) {
                                        $ionicModal.fromTemplateUrl('js/ctrls/layouts/common/add-review-modal.html', {
                                            scope: $scope,
                                            animation: 'slide-in-up'
                                        }).then(function(modal) {
                                            $scope.modal_point = modal;
                                        });
                                    } else {
                                        changeState();
                                    }
                                } else {
                                    changeState();
                                }
                            }
                        });

                    }, function() {
                        // create latest_order_detail_id
                        var objOrder = [latest_order];
                        DbFactory.insert('latest_order_detail_id', objOrder);
                        DbFactory.get('latest_order_detail_id').then(function(data) {
                            $rootScope.LatestOrder = data[0];
                        });
                        // if no review show modal
                        if (review_flag == null) {
                            if (registered_business_date_unix > $moment().subtract(1, 'Month').unix()) {
                                $ionicModal.fromTemplateUrl('js/ctrls/layouts/common/add-review-modal.html', {
                                    scope: $scope,
                                    animation: 'slide-in-up'
                                }).then(function(modal) {
                                    $scope.modal_point = modal;
                                });
                            } else {
                                changeState();
                            }
                        } else {
                            changeState();
                            $scope.saving = false;
                        }
                    });
                } else {
                    changeState();
                    $scope.saving = false;
                }

            },function(res){
                $ionicLoading.hide();
                $scope.saving = false;
            });
        }

        function changeState() {
            if ($rootScope.from_reservation == 1) {
                $rootScope.from_reservation = 0;
                $rootScope.reservation_login = 1;
                $window.history.go(-1);
            } else {
                $ionicHistory.nextViewOptions({
                    disableAnimate: true
                });
                $state.go('home');
            }
        }

        // TODO : remove this after developing of Customer API
        DbFactory.tableExist('customer').then(function() {
            DbFactory.get('customer').then(function(data) {
                $rootScope.Customer = data[0];
                DbFactory.tableExist('auth_customer').then(function() {
                    DbFactory.get('auth_customer').then(function(data) {
                        $rootScope.Auth = data[0];
                        checkLatestOrder()
                    });
                });
            });
        });

        $scope.login = function() {
            $scope.saving = true;
            $scope.errors = null;

            $rootScope.connected = 'connected';
            if ($rootScope.from_reservation != 1) {
                $ionicHistory.clearCache();
                $ionicHistory.clearHistory();
            }

            // Setup the loader
            $ionicLoading.show(config.loading);
            apiRequesterService.login($scope.data).then(function(res) {
                $scope.err = false;
                $rootScope.Auth = res.data.AuthCustomer;

                DbFactory.drop('auth_customer').then(function() {
                    // save auth to local
                    var authData = [$rootScope.Auth];
                    DbFactory.insert('auth_customer', authData);
                });

                if(typeof(FCMPlugin) !== "undefined"){
                    //get device id
                    FCMPlugin.getToken(
                        function(device_id){
                            $rootScope.device_id = device_id;
                            apiRequesterService.registerDeviceId($rootScope.Auth.customer_id, device_id, $rootScope.Auth.access_token);
                        },
                        function(err){
                            $log.debug('error retrieving token: ' + err);
                        }
                    );
                }

                // get customer id and email and add to rootscope
                apiRequesterService.getInfo($rootScope.Auth.customer_id, $rootScope.Auth.access_token).then(function(res) {
                    $rootScope.Customer = res.data.Customer;
                    DbFactory.drop('customer').then(function() {
                        // save customer data to local
                        var customerData = [$rootScope.Customer];
                        DbFactory.insert('customer', customerData);
                        // remove visit home for new login
                        $rootScope.visit_home = null;
                        $rootScope.logged_in = true;
                        checkLatestOrder();
                    });
                    $ionicLoading.hide();
                }, function() {
                    $ionicLoading.hide();
                });
            }, function(res) {
                $ionicLoading.hide();
                $scope.err = true;
                $scope.errors = res;
                $scope.saving = false;
            });
        }

        $scope.confirm = function() {
            $ionicHistory.nextViewOptions({
                disableAnimate: true
            });
            $scope.err = false;
            $scope.errors = undefined;
            $state.go('confirm');
        }

        $scope.forgot = function() {
            $ionicHistory.nextViewOptions({
                disableAnimate: true
            });
            $scope.err = false;
            $scope.errors = undefined;
            $state.go('forgot');
        }

        $scope.autoLogin = function() {
            $scope.data = $rootScope.credential;
            $rootScope.credential = undefined;
            $scope.login();
        }

        // return first word from name
        $scope.mySplit = function(string, nb) {
            var array = string.split('　');
            return array[nb];
        }
        apiRequesterService.checkConnection();

          // DISPLAYING TERM MODAL
        $ionicModal.fromTemplateUrl('login-modal.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function(modal) {
            $scope.modal = modal;
        });

        $scope.openModal = function() {
            $scope.modal.show();
        }

        $scope.closeModal = function() {
            $scope.modal.hide();
        };

        $scope.linkToConfirm = function() {
            $scope.modal.hide();
            $state.go('confirm');
        }

        $scope.goToTerms = function() {
            $scope.modal.hide();
        }

        // Enable back button where applicable
        $scope.$on('$stateChangeSuccess', function ($scope, toState, toParams, fromState) {
            if (toState.name === 'login') {
                var reservation_pages = [
                    'map',
                    'therapist-ranking-list'
                ];

                if (reservation_pages.indexOf(fromState.name) != -1 && $rootScope.from_reservation == 1) {
                    $rootScope.showBackButton = true;
                    $('.header__menu').addClass('header__menu--back');
                } else {
                    $rootScope.from_reservation = null;
                    $rootScope.showBackButton = false;
                    $('.header__menu').removeClass('header__menu--back');
                }
            }
        });
    }
})();
