/*
 * RegisterChangeEmailCtrl
 *
 * responsible for registration change email
 * view : change-email.html
 */
(function() {
    'use strict';

    angular
        .module('starter')
        .controller('RegisterChangeEmailCtrl', RegisterChangeEmailCtrl);

    function RegisterChangeEmailCtrl($scope, $log, $rootScope, $state, $ionicLoading, apiRequesterService, errorFactory, Flash, config) {
      $scope.input = {
        email: '',
        error: false,
        error_message: '',
        id: ''
      }
      apiRequesterService.checkConnection().then(function(res){
        if (typeof $rootScope.pos_customer !== 'undefined') {
          $scope.input.id = $rootScope.pos_customer.Customer.id;
        }
      }, function(err) {
        $ionicLoading.hide();
        $rootScope.connected = 'noConnection';
      })

      $scope.changeEmail = function() {
        $ionicLoading.show(config.loading);
        apiRequesterService.posCustomerChangeEmail($scope.input).then(function(res){
          // update email
          $rootScope.credential.email = $scope.input.email;
          $ionicLoading.hide();
          $state.go('register-activate');
        }, function(err) {
          $ionicLoading.hide();
          if (typeof err !== 'undefined') {
            $scope.input.error = true;
            $scope.input.error_message = err.Customer.email[0];
          } else {
            $rootScope.connected = 'noConnection';
          }
        })
      }
    }
})();
