(function() {
    'use strict';

    angular
        .module('starter')
        .controller('RegisterCtrl', RegisterCtrl);

    function RegisterCtrl($scope, $ionicPopup, $log, $rootScope, $state, $ionicLoading, config, apiRequesterService, $ionicHistory) {
        $scope.$on('$stateChangeSuccess', function() {

            if ($state.current.url == '/register' && $rootScope.connected == 'connected') {
                $scope.customer_info = $rootScope.CustomerRegister;
            }
        });
        $scope.data = {};
        $rootScope.pos_customer = {};
        // default value
        $scope.data.mail_flg = 1;
        $scope.saving = false;

        $scope.register = function() {
            $scope.errors = null;
            $scope.saving = true;
            apiRequesterService.checkConnection().then(function(res){
                $rootScope.connected = 'connected';
                $ionicLoading.show(config.loading);
                $scope.data.customer_id = $scope.customer_info.customer_id;
                $scope.data.phone_no = $scope.customer_info.phone_no;
                $scope.data.pref_id = $scope.customer_info.pref_id;
                $scope.data.city = $scope.customer_info.city;
                $scope.data.street = $scope.customer_info.street;

                apiRequesterService.register($scope.data).then(function(res) {
                    $rootScope.credential = {
                        'email': $scope.data.email,
                        'password': $scope.data.password
                    };
                    $scope.err = false;
                    $scope.data = {};
                    $ionicLoading.hide();
                    $ionicHistory.nextViewOptions({
                        disableAnimate: true
                    });
                    if (typeof res !== 'undefined') {
                      $rootScope.pos_customer = res.data
                      $rootScope.is_customer_registration_page = true
                      $rootScope.isSmsBased = false;
                      $state.go('register-activate');
                      $scope.saving = false;
                    }
                }, function(res) {
                    $scope.err = true;
                    $scope.errors = res.Customer;
                    $ionicLoading.hide();
                    $scope.saving = false;
                });

            },function(res){
                $ionicLoading.hide();
                $scope.err = false;
                $scope.errors = undefined;
                $rootScope.connected = 'noConnection';
                $scope.saving = false;
            });
        }
    }
})();
