/*
 * ConfirmCodeCtrl
 *
 * responsible for confirm sent 4 digits code
 * view : confirm-code.html
 */
(function() {
    'use strict';

    angular
        .module('starter')
        .controller('ConfirmCodeCtrl', ConfirmCodeCtrl);

    function ConfirmCodeCtrl($scope, $log, $rootScope, $state, $ionicLoading, config, apiRequesterService, $ionicHistory) {

        $scope.saving = false;

        $scope.data = {};

        $scope.confirm = function() {
            $scope.saving = true;
            $ionicLoading.show(config.loading);
            apiRequesterService.confirmCode($rootScope.CustomerPassword.email, $scope.data.code)
                .then(function(res) {
                    $scope.data = {};
                    $rootScope.CustomerPassword.customer_id = res.data.Customer.customer_id;
                    $ionicHistory.nextViewOptions({
                        disableAnimate: true
                    });
                    $state.go('new-passwd');
                    $scope.data = {};
                    $scope.errors = null;
                }, function(err) {
                    $scope.errors = err;
                })
                .finally(function() {
                    $scope.saving = false;
                    $ionicLoading.hide();
                });
        }
    }

})();
