/*
 * ForgotPasswdCtrl
 *
 * responsible for confirm registered email address
 * view : forgot-passwd.html
 */
(function() {
    'use strict';

    angular
        .module('starter')
        .controller('ForgotPasswdCtrl', ForgotPasswdCtrl);

    function ForgotPasswdCtrl($scope, $log, $rootScope, $state, $ionicLoading, config, apiRequesterService, $ionicHistory) {

        $scope.saving = false;

        $scope.data = {};
        $rootScope.CustomerPassword = {};

        $scope.forgot = function() {
            $scope.saving = true;
            $ionicLoading.show(config.loading);
            apiRequesterService.forgotPassword($scope.data.email)
                .then(function(res) {
                    $rootScope.CustomerPassword.email = $scope.data.email;
                    $ionicHistory.nextViewOptions({
                        disableAnimate: true
                    });
                    $state.go('confirm-code');
                    $scope.data = {};
                    $scope.errors = null;
                }, function(err) {
                    $scope.errors = err;
                })
                .finally(function() {
                    $scope.saving = false;
                    $ionicLoading.hide();
                });
        }
    }

})();
