/*
 * NewPasswdCtrl
 *
 * responsible for input new password
 * view : new-passwd.html
 */
(function() {
    'use strict';

    angular
        .module('starter')
        .controller('NewPasswdCtrl', NewPasswdCtrl);

    function NewPasswdCtrl($scope, $log, $rootScope, $state, $ionicLoading, config, apiRequesterService, $ionicHistory) {
        $scope.data = {};
        $scope.data.customer_id = $rootScope.CustomerPassword.customer_id;
        $scope.data.email = $rootScope.CustomerPassword.email;
        $scope.data.password = $scope.data.password ? $scope.data.password : '';
        $scope.data.password_confirm = $scope.data.password_confirm ? $scope.data.password_confirm : '';
        $scope.saving = false;

        $scope.confirm = function() {
            $scope.saving = true;
            $ionicLoading.show(config.loading);
            apiRequesterService.newPassword($scope.data)
                .then(function(res) {
                    $ionicHistory.nextViewOptions({
                        disableAnimate: true
                    });
                    $state.go('new-passwd-success');
                    $scope.data = {};
                    $scope.errors = null;
                }, function(err) {
                    $scope.errors = err;
                })
                .finally(function() {
                    $scope.saving = false;
                    $ionicLoading.hide();
                });
        }
    }

})();
