/*
 * UpdateAddressCtrl
 *
 * responsible for displaying UpdatePasswd screen
 * view : update-address.html
 */
(function() {
    'use strict';

    angular
        .module('starter')
        .controller('UpdateAddressCtrl', UpdateAddressCtrl);

    function UpdateAddressCtrl($scope, $log, $state, $rootScope,$ionicLoading, $ionicScrollDelegate, config, Flash, apiRequesterService, errorFactory) {
        $scope.saving = false;

        $scope.data = {};
        $scope.customer_info = $rootScope.Customer;
        $scope.data.street = $scope.customer_info.street;
        $scope.data.city = $scope.customer_info.city;
        $scope.data.prefectures = [];
        
        $scope.data.pref_id = $scope.customer_info.city != '' ? $scope.customer_info.city : 1;
        apiRequesterService.getPrefectures().then(function(res) {
            angular.forEach(res.data, function (value, key) {
                var data = [];
                data['id'] = value.Pref.api_pref_id;
                data['name'] = value.Pref.name.toString();
                if ($scope.customer_info.pref_id == value.Pref.api_pref_id) {
                    $scope.data.pref_id = value.Pref.api_pref_id
                }
                $scope.data.prefectures.push(data);
            });
            $ionicLoading.hide();
        }, function(err) {
            $ionicLoading.hide();
        });

        $scope.$on('$stateChangeSuccess', function() {
            if ($state.current.url != '/customers/change-address' && config.isIOS) {
                if (window.cordova && window.cordova.plugins.Keyboard) {
                    cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
                }    
            }
            Flash.dismiss();
        });
        $("#selectPref").on('touchstart', function(e) {
            if (window.cordova && window.cordova.plugins.Keyboard && config.isIOS) {
                cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);
            }
        });
        $("#selectPref").on('blur', function(e) {
            if (window.cordova && window.cordova.plugins.Keyboard && config.isIOS) {
                cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
            }
         });
        $scope.change = function() {
            $scope.saving = true;
            $ionicLoading.show(config.loading);
            $scope.errors = null;
            $scope.data.customer_id = $scope.customer_info.customer_id;
            apiRequesterService.changeAddress($rootScope.Auth, $scope.data).then(function(res) {
                $scope.saving = false;
                $rootScope.Customer.city = $scope.data.city;
                $rootScope.Customer.pref_id = $scope.data.pref_id;
                $rootScope.Customer.street = $scope.data.street;
                $scope.customer_info = $rootScope.Customer;
                $scope.checkChange();
                var message = '住所を更新しました。';
                $ionicScrollDelegate.scrollTop();
                Flash.create('success', message);
                $ionicLoading.hide();
            }, function(err) {
                $scope.saving = false;
                Flash.dismiss();
                $scope.errors = err;
                $ionicLoading.hide();
            });
            $ionicLoading.hide();
        }

        $scope.checkChange = function(){
            if (($scope.customer_info.pref_id != $scope.data.pref_id) || ($scope.customer_info.city != $scope.data.city) || ($scope.customer_info.street != $scope.data.street)) {
                $scope.address_changed = true;
            } else {
                $scope.address_changed = false;
            }
        }
    }

})();
