/*
 * UpdateEmailCtrl
 *
 * responsible for displaying update email screen
 * view : update-email.html
 */
(function() {
    'use strict';

    angular
        .module('starter')
        .controller('UpdateEmailCtrl', UpdateEmailCtrl);

    function UpdateEmailCtrl($scope, $log, $state, $rootScope,$ionicLoading, config, Flash, apiRequesterService, errorFactory) {
        $scope.saving = false;

        $scope.data = {}
        $scope.original_email = $rootScope.Customer.email;
        $scope.$on('$stateChangeSuccess', function() {
             Flash.dismiss();
        });
        $scope.update = function() {
            $scope.saving = true;
            $ionicLoading.show(config.loading);
            apiRequesterService.updateEmail($rootScope.Auth, $rootScope.Customer, $scope.data.email).then(function(res) {
                $scope.saving = false;
                $scope.err = false;
                var message = '<strong>認証用メールを送信しました。</strong>';
                Flash.create('success', message);
                $scope.error = null;
                $scope.checkChange();
                $ionicLoading.hide();
            }, function(err) {
                $scope.saving = false;
                Flash.dismiss();
                if (typeof err.email != 'undefined') {
                    $scope.error = err.email[0];
                } else if (typeof err.timeOut != 'undefined') {
                    $scope.error = err.timeOut[0];
                }else {
                    $scope.error = 'システムエラーが発生しました。';
                }
                $ionicLoading.hide();
            });
        }

        $scope.checkChange = function(){
            if ($scope.original_email != $scope.data.email && $scope.data.email != '') {
                $scope.email_changed = true;
            } else if ($scope.original_email == $scope.data.email) {
                $scope.email_changed = false;
            } else if ($scope.data.email == '') {
                $scope.email_changed = false;
            }
        }
    }

})();
