/*
 * UpdatePasswdCtrl
 *
 * responsible for displaying UpdatePasswd screen
 * view : update-passwd.html
 */
(function() {
    'use strict';

    angular
        .module('starter')
        .controller('UpdatePasswdCtrl', UpdatePasswdCtrl);

    function UpdatePasswdCtrl($scope, $log, $state, $rootScope,$ionicLoading, config, Flash, apiRequesterService, errorFactory) {

      $scope.saving = false;

        $scope.data = {};   
        $scope.customer_info = $rootScope.Customer;

        $scope.change = function() {
            $scope.saving = true;
            $ionicLoading.show(config.loading);

            $rootScope.connected = 'connected';
            $scope.customer_info.current_password = $scope.data.current_password ? $scope.data.current_password : '' ;
            $scope.customer_info.password = $scope.data.password ? $scope.data.password : '' ;
            $scope.customer_info.password_confirm = $scope.data.password_confirm ? $scope.data.password_confirm : '' ;
            apiRequesterService.changePassword($rootScope.Auth, $scope.customer_info).then(function(res) {
                var message = 'パスワードを更新しました。';
                Flash.create('success', message);
                $scope.data = {};
                $ionicLoading.hide();
                $scope.errors = null;
                $scope.saving = false;
            }, function(err) {
                $scope.errors = err;
                $ionicLoading.hide();
                $scope.saving = false;
            });

            $ionicLoading.hide();
            $scope.saving = false;
        }
    }

})();
