/*
 * UpdateTelCtrl
 *
 * responsible for displaying UpdatePasswd screen
 * view : update-passwd.html
 */
(function() {
    'use strict';

    angular
        .module('starter')
        .controller('UpdateTelCtrl', UpdateTelCtrl);

    function UpdateTelCtrl($scope, $log, $state, $rootScope,$ionicLoading, config, Flash, apiRequesterService, errorFactory) {
        $scope.saving = false;

        $scope.data           = {};
        $scope.customer_info  = $rootScope.Customer;
        var original_phone_no = $scope.customer_info.phone_no;
        $scope.data.phone_no  = $scope.customer_info.phone_no;
        $scope.tel_changed = false;
        $scope.$on('$stateChangeSuccess', function() {
            Flash.dismiss();
        });
        $scope.update = function() {
            $scope.saving = true;
            $ionicLoading.show(config.loading);
            $scope.error = null;
            var phone_no = $scope.data.phone_no;
            $scope.customer_info.phone_no = $scope.data.phone_no;
            apiRequesterService.changeTel($rootScope.Auth, $scope.customer_info).then(function(res) {
                $scope.saving = false;
                var message = '電話番号を変更しました。';
                Flash.create('success', message);
                $ionicLoading.hide();
                $rootScope.Customer = $scope.customer_info;
                $scope.customer_info = $rootScope.Customer;
                $scope.checkChange();
            }, function(err) {
                $scope.saving = false;
                Flash.dismiss();
                $scope.error = err.phone_no[0]
                $rootScope.Customer.phone_no = original_phone_no;
                $ionicLoading.hide();
            });
            $ionicLoading.hide();
        }

        $scope.checkChange = function(){
            if ($scope.customer_info.phone_no != $scope.data.phone_no) {
                $scope.tel_changed = true;
            } else {
                $scope.tel_changed = false;
            }
        }
    }
})();
