/*
 * alertCtrl
 *
 * responsible for displaying side news
 * view : add-review-modal.html
 */
(function() {
    'use strict';

    angular
        .module('starter')
        .controller('reviewmodalCtrl', alertCtrl);

    function alertCtrl($scope, $ionicModal, $rootScope, $state, apiRequesterService) {

      $ionicModal.fromTemplateUrl('add-review-modal.html', {
        scope: $scope,
        animation: 'slide-in-up'
      }).then(function(modal) {
        $scope.modal_point = modal;
        apiRequesterService.selectRewardPoints(2).then(function(res) {
            $scope.point = res.data.RewardPoint.point;
            $scope.modal_point.show(); 
        });
      });

      $scope.openModalPoint = function() {
         $scope.modal_point.show();
      }

      $scope.closeModalPoint = function() {
        $scope.modal_point.hide();
      };

      $scope.$on('$destroy', function() {
        $scope.modal_point.remove();
      });
      let go_review_flag = false;
      $scope.$on('modal.hidden', function() {
        // Execute action
        if (!go_review_flag) {
          $state.go('home');  
        }
        
      });
      // Execute action on remove modal
      $scope.$on('modal.removed', function() {
        // Execute action
      });
      $scope.goReview = function() {
        $rootScope.order_select = {};
        $rootScope.order_select.order_id = $rootScope.LatestOrder.id;
        $rootScope.order_select.order_detail_id = $rootScope.LatestOrder.order_detail_id;
        go_review_flag = true;
        $state.go('add');
        $scope.closeModalPoint();
      }
    }

})();
