/*
 * alertStampModalCtrl
 *
 * responsible for displaying side news
 * view : add-review-modal.html
 */
(function() {
    'use strict';

    angular
        .module('starter')
        .controller('alertStampModalCtrl', alertStampModalCtrl);

    function alertStampModalCtrl($scope, $ionicModal, $rootScope, $state, apiRequesterService) {

      $ionicModal.fromTemplateUrl('alert-stamp-modal.html', {
        scope: $scope,
        animation: 'slide-in-up'
      }).then(function(modal) {
        $scope.modal_stamp = modal;
        $scope.modal_stamp.show();
      });

      $scope.openModal = function() {
         $scope.modal_stamp.show();
      }

      $scope.closeModal = function() {
        $scope.modal_stamp.hide();
      };

      $scope.$on('$destroy', function() {
        $scope.modal_stamp.remove();
      });
      
      $scope.$on('modal.hidden', function() {
        // Otherwise, just close
      });

      // Execute action on remove modal
      $scope.$on('modal.removed', function() {
        // Execute action
      });
    }

})();
