/*
 * alertCtrl
 *
 * responsible for displaying side news
 * view : alert.html
 */
(function() {
    'use strict';

    angular
        .module('starter')
        .controller('alertCtrl', alertCtrl);

    function alertCtrl($scope, $rootScope, $moment, $state, $ionicModal, $ionicLoading) {
        function checkPointExpiration() {
            if (typeof $rootScope.Customer != 'undefined' &&  $rootScope.Customer != null && $rootScope.home_loaded == true) {
              $scope.Customer = $rootScope.Customer;
              var bonus_point = parseInt($scope.Customer.current_bonus_point);
              var charge_point = parseInt($scope.Customer.current_charge_point);
              $scope.Customer.total_points = charge_point + bonus_point;

              var bonus_expiration = new Date($scope.Customer.expiration_date_of_bonus_point);
              var charge_expiration = new Date($scope.Customer.expiration_date_of_charge_point);

              let two_months_ago_of_expired_bonus  = $moment(bonus_expiration).subtract(2, 'Months');
              let two_months_ago_of_expired_charge = $moment(charge_expiration).subtract(2, 'Months');
              let todays_date  = $moment().format('YYYY-MM-DD');

              // set to start of the next month
              two_months_ago_of_expired_bonus  = $moment(two_months_ago_of_expired_bonus).add(1, 'Day');
              two_months_ago_of_expired_charge = $moment(two_months_ago_of_expired_charge).add(1, 'Day');
              // +1 day if true
              if (parseInt($moment().format('hmm')) > 600) {
                  two_months_ago_of_expired_bonus = $moment(two_months_ago_of_expired_bonus).subtract(1, 'days');
                  two_months_ago_of_expired_charge = $moment(two_months_ago_of_expired_charge).subtract(1, 'days');
              }

              $scope.show_red_lable = false;
              // between of expired date
              let today_unix = $moment(todays_date).unix();
              // between of expired date
              if (today_unix >= $moment(two_months_ago_of_expired_bonus).unix()
                  && today_unix <= $moment(bonus_expiration).unix() && bonus_point > 0) {
                  $scope.show_red_lable = true;
              }

              if (today_unix >= $moment(two_months_ago_of_expired_charge).unix()
                  && today_unix <= $moment(charge_expiration).unix() && charge_point > 0) {
                  $scope.show_red_lable = true;
              }

              if ($scope.show_red_lable == true && $rootScope.point_modal_shown == null && $state.current.url == '/home' && $rootScope.home_loaded == true && $rootScope.banner_exist == false) {
                  $scope.show_red_lable = true;
                  // $rootScope.openModal();
                  // $rootScope.point_modal_shown = 1;
              }
            } else {
              $scope.show_red_lable = false;
            }
        }

      // get customer detail info and add to rootscope
      $scope.$on('$stateChangeSuccess', function() {
          $scope.order = null;
          if ($state.current.url == '/home') {
            checkPointExpiration();
          }
      });

      $scope.$watch(function() { return $rootScope.home_loaded; }, function() {
        checkPointExpiration();
      }, true);

      $scope.$watch(function() { return $rootScope.first_home_visit; }, function() {
        checkPointExpiration();
      }, true);

      $ionicModal.fromTemplateUrl('alert-modal.html', {
        scope: $scope,
        animation: 'slide-in-up'
      }).then(function(modal) {
        $scope.modal = modal;
      });


      $scope.openModal = function() {
           $scope.modal.show();
      }

      $scope.closeModal = function() {
        $scope.modal.hide();
      };

      $scope.$on('$destroy', function() {
        $scope.modal.remove();
      });

      $scope.$on('modal.hidden', function() {
        // Execute action
      });
      // Execute action on remove modal
      $scope.$on('modal.removed', function() {
        // Execute action
      });
      checkPointExpiration();
    }

})();
