/*
 * CouponsList
 *
 * responsible for deactivating customer account
 * view : coupon.html
 */
(function() {
  'use strict';

  angular
      .module('starter')
      .controller('CouponsList', CouponsList);

  function CouponsList($scope,$rootScope, $ionicScrollDelegate, $ionicModal, $ionicLoading, $timeout) {

    $scope.items = $rootScope.coupons;
    $ionicLoading.show();
    $scope.remarks = null;
    var remark_index = 0;

    $scope.finished = function() {
      angular.element(document).ready(function () {
        $timeout(function() {

          var $slick = $('.slide__list');

          if($slick.hasClass("slick-initialized")) {
            $slick.slick("unslick");
          }

          $slick.on('init', function(event, slick){
            $(".slide__item").each(function(){
              let slide = this;

              var imageElement = $(this).find('img.slide__image');
              resizeSlide(slide);
              imageElement.on('load error', function() {
                resizeSlide(slide);
              })
            });
          });

          $slick.slick({
            infinite: true,
            slidesToShow: 1,
            slidesToScroll: 1,
            dots: true,
            initOnload: true,
            data: "coupons",
            centerMode: true,
            centerPadding: '30px',
            prevArrow: $('#js-arrow-prev'),
            nextArrow: $('#js-arrow-next'),
          });

          $ionicLoading.hide();
        }, 1000);
      });
    }

    function resizeSlide(slide) {
      var slideHeight = slide.offsetHeight;

      var notesElement = $(slide).find('div.notes.notes--coupon');

      if(notesElement.length !== 0){
        var topPadding = slideHeight * 0.25;

        notesElement.css({
          "height": slideHeight,
          "padding-top": topPadding
        });
      }
    }

    $('.slide__list').on('afterChange', function(event, currentSlide) {
      remark_index = currentSlide['currentSlide'];
    });

    $scope.bc = {
        format: 'CODE128',
        lineColor: '#222222',
        width: 6,
        height: 150,
        displayValue: false,
        background: '#ffffff',
        margin: 0,
        marginTop: undefined,
        marginBottom: undefined,
        marginLeft: undefined,
        marginRight: undefined,
        valid: function (valid) {
        }
    }

    $scope.showBarcode = function(item) {
      if (item.is_login_user == 0 || (item.is_login_user == 1 && $scope.customer != null)) {
        $('.list-'+item.id).find('.slide__toggle').hide();
        $('.list-'+item.id).find('.barcode--coupon').slideDown();
        $('.slick-dots').hide();
        $('.slide__list').slick("slickSetOption", "swipe", false);
        $('.slide__arrow-link').css('visibility','hidden');
      }
    }

    $scope.closeBarcode = function(item) {
      $('.list-'+item.id).find('.slide__toggle').show();
      $('.list-'+item.id).find('.barcode--coupon').slideUp();
      $('.slick-dots').show();
      $ionicScrollDelegate.scrollTop(800);
      $('.slide__list').slick("slickSetOption", "swipe", true);
      $('.slide__arrow-link').css('visibility','visible');
    }

      // DISPLAYING TERM MODAL
    $ionicModal.fromTemplateUrl('coupon-terms.html', {
      scope: $scope,
      animation: 'slide-in-up'
    }).then(function(modal) {
      $scope.modal = modal;
    });

    $scope.openModal = function() {
      $scope.remarks = $scope.items[remark_index].remarks;
      $scope.modal.show();
    }

    $scope.closeModal = function() {
      $scope.modal.hide();
    };
    // END OF DISPLAYING TERM MODAL
  }
})();
