/*
 * newsCtrl
 *
 * responsible for displaying side news
 * view : news.html
 */
(function() {
    'use strict';

    angular
        .module('starter')
        .controller('newsCtrl', newsCtrl);

    function newsCtrl($scope, $rootScope, $state, $ionicPlatform, apiRequesterService, config, headerTitleService, $ionicPopup) {

      $scope.showFirstPage = function() {
        $('.news__tab-item'+newsClass).removeClass('news__tab-item--active')
        $('.news__tab-item'+newsClass+':first-child').addClass('news__tab-item--active');
        $('.news__content'+newsClass).removeClass('news__content--show');
        $('.news__content'+newsClass+':first-child').addClass('news__content--show');
        $rootScope.current_news_tab = 1;
        getNews(1, $rootScope.news_limit);
      }

      $scope.showSecondPage = function() {
        $('.news__tab-item'+newsClass).removeClass('news__tab-item--active')
        $('.news__tab-item'+newsClass+':nth-child(2)').addClass('news__tab-item--active');
        $('.news__content'+newsClass).removeClass('news__content--show');
        $('.news__content'+newsClass+':nth-child(2)').addClass('news__content--show');
        $rootScope.current_news_tab = 2;
        getNews(2, $rootScope.news_limit);
      }

      $scope.showThirdPage = function() {
        $('.news__content'+newsClass).removeClass('news__content--show');
        $('.news__content'+newsClass+':nth-child(3)').addClass('news__content--show');
        $('.news__tab-item'+newsClass).removeClass('news__tab-item--active')
        $('.news__tab-item'+newsClass+':last-child').addClass('news__tab-item--active');
        $rootScope.current_news_tab = 3;
        getNews(3, $rootScope.news_limit);
      }

      var newsClass = '';
      if ($rootScope.current_news_tab === undefined) {
        $rootScope.current_news_tab = 1;
      }

      function getNews(news_type, limit){
          $rootScope.connected = 'connected';
          apiRequesterService.getNews(news_type, limit).then(function(res){
              $rootScope.news_shop = [];
              $rootScope.news_media = [];
              $rootScope.news_news = [];
              if (news_type == 1) {
                  appendToArray($rootScope.news_shop, res.data);
              } else if (news_type == 2) {
                  appendToArray($rootScope.news_media, res.data)
              } else {
                  appendToArray($rootScope.news_news, res.data)
              }
              $rootScope.noMoreNewsAvailable = false;
              if ($state.current.url=='/news/list') {
                  $rootScope.news_offset = limit;
                  $rootScope.belong_page = 'news';
              }
          });
      }

      function appendToArray(news_array, res_data){
          if (news_array.length == 0 && res_data.length != 0) {
              angular.forEach(res_data, function(value, key){
                  news_array[value.News.id] = {
                     id : value.News.id,
                     start_dt : value.News.start_dt,
                     title : value.News.title,
                     free_space_pc : value.News.free_space_pc,
                     url : value.News.url1,
                     created : value.News.created
                  };
              });
              formatDates(news_array);
          }
      };

      function formatDates(news_array) {
          angular.forEach(news_array, function(value,key){
              value.start_dt = value.start_dt.split(' ')[0];
          });
      }

      $scope.goToNewsList = function(){
          $state.go('news');
      }

      $scope.goToDetail = function(news) {
          if (news.url != null && news.url != '') {
              $rootScope.parameter = news.url;
              if ($state.current.url == '/home') {
                $rootScope.belong_page = 'home';
              } else {
                $rootScope.belong_page = 'news';
              }
              headerTitleService.setHeaderName('ニュース詳細');
              var target = '_system';
              if (config.isAndroid) {
                  target = '_self'
              }
              var confirmPopup = $ionicPopup.confirm({
                  title: 'ブラウザで開く',
                  template: 'このページはアプリでは開けないため、ブラウザが起動しますがよろしいですか？',

                  buttons: [{
                        text: 'いいえ',
                        type: 'button-disable'
                      },{
                        text: 'はい',
                        type: 'button-positive',
                        onTap: function(e) {
                          window.open($rootScope.parameter, target, 'location=yes')
                        }
                      }
                    ]
                });
          } else {
              $rootScope.News = news;
              $state.go('news-detail', {'id':news.id});
          }
      }

      $scope.$on('$stateChangeSuccess', function(){
        if ($rootScope.first_home_visit != null && $state.current.url == '/home') {
          $rootScope.news_limit = 3;
          $rootScope.news_offset = 0;
          newsClass = '.news-home';
        } else {
          newsClass = '.news-list';
        }
        switch($rootScope.current_news_tab) {
          case 1:
            $scope.showFirstPage();
            break;
          case 2:
            $scope.showSecondPage();
            break;
          case 3:
            $scope.showThirdPage();
            break;
          default:
            $scope.showFirstPage();
            break;
        }
      });
    }
})();