/*
 * versionNotification
 *
 * checks for update
 * view : version-notification.html
 */
(function() {
    'use strict';

    angular
        .module('starter')
        .controller('versionNotification', versionNotification);

    function versionNotification($scope, $ionicModal, apiRequesterService) {
        $scope.openStore = function () {
            window.open($scope.linkToDownload, '_system');
        }
        $ionicModal
            .fromTemplateUrl('version-notification.html', {
                scope: $scope,
                animation: 'slide-in-up'
            })
            .then(function (modal) {
                if (ionic.Platform.isAndroid()) {
                    $scope.buttonText = 'Google Playを開く';
                    $scope.linkToDownload = 'https://play.google.com/store/apps/details?id=com.riracle.mypage';
                } else {
                    $scope.buttonText = 'App Storeを開く';
                    $scope.linkToDownload = 'https://itunes.apple.com/jp/app/rirakuru-gong-shiapuri/id1178531844?l=ja&ls=1&mt=8';
                }
                $scope.modal = modal;
            });
        document.addEventListener('deviceready', function () {
            cordova.getAppVersion.getVersionNumber().then(function (versionCode) {
                let platform = ionic.Platform.platform();
                let version = versionCode;
                version = version.replace(/\./g, "");
                apiRequesterService.checkForUpdate(platform).then(
                    function (res) {
                        let apiVersion = res.data.version;
                        apiVersion = apiVersion.replace(/\./g, "");
                        if (apiVersion > version) {
                            $scope.modal.show();
                        }
                    }
                );
            });
        });
    }
})();
