/*
 * WebViewCtrl
 *
 * responsible for displaying side news
 * view : webview.html
 */
(function () {
  'use strict';

  angular
    .module('starter')
    .controller('WebViewCtrl', WebViewCtrl)
    .filter('trustThisUrl', ['$sce', function ($sce) {
      return function (url) {
        return $sce.trustAsResourceUrl(url);
      };
    }]);

  function WebViewCtrl($scope, $ionicLoading, $timeout) {

    $ionicLoading.show();
    $scope.$on('$stateChangeSuccess', function () {
      var iframe = $('#i_frame');
      iframe.on('load', function () {
        $ionicLoading.hide();
      });
    });

    $timeout(function () {
      $ionicLoading.hide();
    }, 5000);

  }

})();
