/*
 * NaviCtrl
 *
 * responsible for displaying side navi
 * view : navi.html
 */
(function() {
  'use strict';

  angular
      .module('starter')
      .controller('NaviCtrl', NaviCtrl);

  function NaviCtrl($scope, $log, $state, $ionicSideMenuDelegate, $ionicHistory, $rootScope, $ionicPopup, apiRequesterService, DbFactory, config, errorFactory, checkConnectionService, $cordovaInAppBrowser) {

    $scope.$watch(function() { return checkConnectionService.getConnectionStatus(); }, function(newConnectionStatus) { 
      $scope.isConnected = newConnectionStatus.connection_status;
    }, true);

    $scope.showMenu = function () {
      $ionicSideMenuDelegate.toggleLeft();
      $('span.close-clk').click();
    };

    $scope.isMenuOpen = function() {
      return $ionicSideMenuDelegate.isOpen();
    };

    $scope.app_info = function() {
      $state.go( "app.info" );
    }

    $scope.survey = function() {
      $state.go('surveys');
    }
    $scope.goPointHistory = function() {
      if (typeof $rootScope.Customer != 'undefined' && $rootScope.Customer != null) {
        $state.go('history');
      } else {
        $state.go('login');
      }
    }
    $scope.logout = function() {
        errorFactory.logoutErrorHandling();
    }

    // About Point (Web View)
    $scope.aboutPoint = function() {
      if(config.isIOS) {
        var ref = cordova.InAppBrowser.open(config.webServer + '/usr/about_point', '_blank', 'location=no');
        ref.addEventListener('loadstart', function(event) {
            if (window.cordova && window.cordova.plugins.Keyboard) {
              cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);
            }
        });

        ref.addEventListener('exit', function(event) {
          if (window.cordova && window.cordova.plugins.Keyboard) {
            cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
          }
        });
      } else {
        $rootScope.parameter = config.webServer + '/usr/about_point';
        $state.go('about-point');
      }
    }

    // TERMS COMPANY
    $scope.terms = function() {
      if(config.isIOS) {
        var ref = cordova.InAppBrowser.open(config.webServer + '/usr/terms', '_blank', 'location=no');
        ref.addEventListener('loadstart', function(event) {
            if (window.cordova && window.cordova.plugins.Keyboard) {
              cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);
            }
        });

        ref.addEventListener('exit', function(event) {
          if (window.cordova && window.cordova.plugins.Keyboard) {
            cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
          }
        });
      } else {
        $rootScope.parameter = config.webServer + '/usr/terms';
        $state.go('terms');
      }
    }

    // TERMS POLICY
    $scope.policy = function () {
      if(config.isIOS) {
        var ref = cordova.InAppBrowser.open(config.webServer + '/company/policy', '_blank', 'location=no');
        ref.addEventListener('loadstart', function(event) {
            if (window.cordova && window.cordova.plugins.Keyboard) {
              cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);
            }
        });

        ref.addEventListener('exit', function(event) {
          if (window.cordova && window.cordova.plugins.Keyboard) {
            cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
          }
        });
      } else {
        $rootScope.parameter = config.webServer + '/company/policy';
        $state.go('policy');
      }
    }

    // TERMS COMPANY
    $scope.company = function () {
      if(config.isIOS) {
        var ref = cordova.InAppBrowser.open(config.webServer + '/company', '_blank', 'location=no');
        ref.addEventListener('loadstart', function(event) {
            if (window.cordova && window.cordova.plugins.Keyboard) {
              cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);
            }
        });

        ref.addEventListener('exit', function(event) {
          if (window.cordova && window.cordova.plugins.Keyboard) {
            cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
          }
        });
      } else {
        $rootScope.parameter = config.webServer + '/company';
        $state.go('company');
      }
    }

    // CONTACT US
    $scope.contactUs = function () {
      if(config.isIOS) {
        var ref = cordova.InAppBrowser.open(config.webServer + '/usr/inquiry/index', '_blank', 'location=no');
        ref.addEventListener('loadstart', function(event) {
            if (window.cordova && window.cordova.plugins.Keyboard) {
              cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);
            }
        });

        ref.addEventListener('exit', function(event) {
          if (window.cordova && window.cordova.plugins.Keyboard) {
            cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
          }
        });
      } else {
        $rootScope.parameter = config.webServer + '/usr/inquiry/index';
        $state.go('contact-us');
      }
    }
  }


})();
