/*
 * NewsDetailCtrl
 *
 * responsible for displaying order history email screen
 * view : news.html
 */
(function() {
    'use strict';

    angular
        .module('starter')
        .controller('NewsDetailCtrl', NewsDetailCtrl);

    function NewsDetailCtrl($scope, $log,$ionicLoading, $rootScope, $state, $q, config, apiRequesterService, errorFactory, $sce, $ionicPopup) {
        // TODO: Uncomment this once #APP News Detail is done
        $scope.news_date = $rootScope.News.start_dt;
        $scope.news_title = $rootScope.News.title;
        $scope.news_content = $rootScope.News.free_space_pc;
        $scope.news_content = $scope.news_content.replace(/\/upload_file\/news/g, config.webServer + '/upload_file/news');
        $scope.trustedHtml = $sce.trustAsHtml($scope.news_content);

        $scope.goToNewsList = function(){
          $state.go('news');
        }

        $(document).ready(function() {
            $('#news_content a').on('click', function(e) {
                e.preventDefault();
                $rootScope.parameter = $(this).attr('href');
                var target = '_system';
                if (config.isAndroid) {
                  target = '_self'
                }
                var confirmPopup = $ionicPopup.confirm({
                  title: 'ブラウザで開く',
                  template: 'このページはアプリでは開けないため、ブラウザが起動しますがよろしいですか？',

                  buttons: [{
                      text: 'いいえ',
                      type: 'button-disable'
                  },{
                      text: 'はい',
                      type: 'button-positive',
                      onTap: function(e) {
                          window.open($rootScope.parameter, target, 'location=yes')
                      }
                    }
                  ]
                });
            });
        });

        apiRequesterService.checkConnection();
    }
})();

