/*
 * PosRegisterConfirmCtrl
 *
 * responsible for pos registration info confirmation
 * view : register-confirm.html
 */
(function() {
    'use strict';

    angular
        .module('starter')
        .controller('PosRegisterConfirmCtrl', PosRegisterConfirmCtrl);

    function PosRegisterConfirmCtrl($scope, $log, $rootScope, $state, $ionicLoading, apiRequesterService, config,errorFactory, Flash) {
      $rootScope.pos_customer = {};

      $scope.register = function () {
        apiRequesterService.checkConnection().then(function(res) {
          $ionicLoading.show(config.loading);
          apiRequesterService.posRegister($rootScope.input).then(function(res){
            $rootScope.credential = {
              'email': $rootScope.input.email,
              'password': $rootScope.input.password
            };
            if (typeof res === 'object') {
              $ionicLoading.hide();
              $rootScope.pos_customer = res.data;
              $rootScope.input.name = '';
              $rootScope.input.birth_date = '';
              $rootScope.input.phone_no = '';
              $rootScope.input.email = '';
              $rootScope.input.password = '';
              $rootScope.input.password_confirm = '';
              $rootScope.input.gender = '1';
              $rootScope.input.mail = '0';
              $rootScope.input.zip_code1 = '';
              $rootScope.input.zip_code2 = '';
              $rootScope.birth_date.birth_year = '----';
              $rootScope.birth_date.birth_month = '--';
              $rootScope.birth_date.birth_day = '--';
              $rootScope.isSmsBased = false;
              $state.go('register-activate');
            }
          }, function(err) {
            $ionicLoading.hide();
            $rootScope.connected = 'noConnection';
          });
        }, function(res) {
            $rootScope.connected = 'noConnection';
        });
      }

      $scope.return = function () {
        $state.go('pos-register');
      }

    }
})();
