/*
 * reviewaddCtrl
 *
 * responsible for displaying order history email screen
 * view : add.html
 */
(function() {
    'use strict';

    angular
        .module('starter')
        .controller('reviewaddCtrl', reviewaddCtrl);

    function reviewaddCtrl($scope,$stateParams, $rootScope, apiRequesterService, config, $ionicLoading, $ionicModal, $state, $ionicHistory, $ionicPopup) {
        // limit of order detail
        let limit    = 7;
        let offset   = 0;
        let order_id = $rootScope.order_select.order_id;
        let order_detail_id = $rootScope.order_select.order_detail_id
        $scope.data = {};
        $scope.data.rank = 3;
        $scope.data.rank_img = [];
        $scope.star_description = ['VERY_BAD', 'BAD', 'NORMAL', 'GOOD', 'EXCELLENT'];
        $scope.error = {};
        $scope.have_review = false;
        $scope.saving = false;

        // Modal Settings
        $ionicModal.fromTemplateUrl('js/ctrls/layouts/common/review-point-modal.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function(modal) {
            $scope.modal = modal;
        });
        // Modal Actions
        $scope.openModal = function(point) {
            $scope.point = point;
            $scope.modal.show();
        };

        $scope.showConfirmModal = function() {
            var confirmPopup = $ionicPopup.confirm({
                title: 'ブラウザで開く',
                template: 'このページはアプリでは開けないため、ブラウザが起動しますがよろしいですか？',

                buttons: [{
                    text: 'いいえ',
                    type: 'button-disable'
                },
                {
                    text: 'はい',
                    type: 'button-positive',
                    onTap: function(e) {
                        window.open(config.webServer + '/usr/inquiry/index', '_system', 'location=yes')
                    }
                }]
            });
        };


        $scope.closeModal = function() {
            $scope.modal.hide();
        };

        $scope.$on('modal.hidden', function() {
            $ionicHistory.goBack();
        });

        // return first word from name
        $scope.mySplit = function(string, nb) {
            var array = string.split('　');
            return array[nb];
        }
        $scope.getRank = function(rank_level) {

            $scope.data.rank = rank_level;
            $scope.data.rank_img = [];
            $scope.data.star_description = $scope.star_description[rank_level-1];
            rank_level = rank_level == null ? 3 : rank_level;
            for (var i = 1; i <= 5; i++) {
                $scope.data.rank_img[i] = {};
                if (i<=rank_level ) {
                    $scope.data.rank_img[i].src = 'img/icons/rate-active.png'
                } else {
                    $scope.data.rank_img[i].src = 'img/icons/rate-inactive.png'
                }
            }
        }
        apiRequesterService.checkConnection().then(function(res){
            $ionicLoading.show(config.loading);
            $rootScope.connected = 'connected';
            apiRequesterService.getOrders($rootScope.Customer.customer_id,$rootScope.Auth, limit, offset,true,order_id).then(function(res) {
                if (res.length !== 0) {
                    angular.forEach(res.data, function(value, key){
                        if (value.Order.OrderDetail.id == order_detail_id) {
                            if (typeof value.Order.Review != 'undefined') {
                                $scope.have_review = true;
                                $scope.data        = value.Order.Review;
                                $scope.getRank(value.Order.Review.rank)
                            } else {
                                $scope.getRank(3);
                            }
                            $scope.data.order_detail = value.Order.OrderDetail.id;
                            $scope.order = {
                                registerd_business_date: value.Order.registered_business_date,
                                product_names : value.Order.product_names,
                                total_sub_total : value.Order.total_sub_total,
                                total_amount_of_price : value.Order.total_amount_of_price,
                                shop_name: value.Order.shop_name,
                                therapist_name: $scope.mySplit(value.Order.OrderDetail.TherapistNomination.therapist_name, 0),
                                treated_body_parts: value.Order.TreatedBodyPart.id ,
                            };
                        }
                    });
                }
                $ionicLoading.hide();
            }, function(err) {
                $scope.order = null;
                $ionicLoading.hide();
            });
        },function(res){
            $rootScope.connected = 'noConnection';
        });

        $scope.updateReview = function() {
            $scope.saving = true;
            $ionicLoading.show(config.loading);
            apiRequesterService.addReviews($rootScope.Customer.customer_id,$rootScope.Auth, $scope.data, true).then(function(res) {
                updateOrderHistoryList();
                $ionicHistory.goBack();
                $ionicLoading.hide();
                $scope.saving = false;
            }, function(err) {
                $scope.error.id = typeof err.Review.id != 'undefined' ? err.Review.id : null;
                $scope.error.comment = typeof  err.Review.comment != 'undefined' ?  err.Review.comment[0] : null;
                $ionicLoading.hide();
                $scope.saving = false;
            });
        }
        $scope.addReview = function() {
            $scope.saving = true;
            $ionicLoading.show(config.loading);
            apiRequesterService.addReviews($rootScope.Customer.customer_id,$rootScope.Auth, $scope.data).then(function(res) {
                let point     = 10;
                let review_id = res.data.Review.review_id;
                apiRequesterService.selectRewardPoints(2).then(function(res) {
                    point = res.data.RewardPoint.point;
                    apiRequesterService.registerPoint($rootScope.Customer, $rootScope.Auth, review_id,2, point).then(function(res) {
                        updateOrderHistoryList();
                        $scope.openModal(point);
                        $ionicLoading.hide();
                        $scope.saving = false;
                    }, function(err) {
                        $scope.errors[value] = err;
                        $ionicLoading.hide();
                        $scope.saving = false;
                    });
                }, function(err) {
                    $scope.errors[value] = err;
                    $ionicLoading.hide();
                    $scope.saving = false;
                });
            }, function(err) {
                $scope.error.id = typeof err.Review.id != 'undefined' ? err.Review.id : null;
                $scope.error.comment = typeof  err.Review.comment != 'undefined' ?  err.Review.comment[0] : null;
                $ionicLoading.hide();
                $scope.saving = false;
            });
        }

        function updateOrderHistoryList(){
            angular.forEach($rootScope.OrderItems, function(key, value) {
                if (key.id == $scope.data.order_detail) {
                    key.stars = $scope.data.rank;
                }
            });
        }
    }


})();
