/*
 * CityCtrl
 *
 * responsible for displaying side navi
 * view : city.html
 */
(function() {
    'use strict';

    angular
        .module('starter')
        .controller('CityCtrl', CityCtrl);

    function CityCtrl ($scope, $rootScope, $state, $ionicLoading, config, apiRequesterService, headerTitleService) {  
        $scope.$on('$stateChangeSuccess', function() {
            // set headerTitle
            if ($state.current.name == 'city') {
                $scope.headerTitle = $rootScope.selected_pref_name;
                headerTitleService.setHeaderName($scope.headerTitle);
            }
            
            $ionicLoading.show(config.loading);
            $scope.pref        = {
                                    id:$rootScope.selected_pref_id, 
                                    name:$rootScope.selected_pref_name,
                                    api_pref_id: $rootScope.selected_api_pref_id
                                 };
            $scope.cities      = [];
            apiRequesterService.checkConnection().then(function(res){
                $rootScope.connected = 'connected';
                // get cities
                apiRequesterService.getCities($scope.pref).then(function(res) {
                    $ionicLoading.hide();
                    angular.forEach(res.data, function (v, k) {
                        v.City.api_pref_id = $scope.pref.api_pref_id;
                        $scope.cities.push(v);
                    });
                }, function() {
                    $ionicLoading.hide();
                });
            },function(res){
                $ionicLoading.hide();
                $scope.err = false;
                $scope.errors = undefined;
                $rootScope.connected = 'noConnection';
            });
        });
        // Go To shop list page 
        $scope.goList = function(data,is_pref) {
            is_pref = is_pref != null ? is_pref : false;
            $rootScope.is_pref = false;
            $rootScope.list_condition = '?pref_id='+data.api_pref_id+'&city_name='+data.name;
            $rootScope.selected_city_name = data.name;
            if (is_pref != false) {
                $rootScope.is_pref = true;
                $rootScope.list_condition = '?pref_id='+data.api_pref_id;
                $rootScope.selected_city_name = '';
            }
            $state.go('list');
        }
    }    
})();
