/*
 * listCtrl
 *
 * responsible for displaying side navi
 * view : navi.html
 */
(function() {
    'use strict';

    angular
        .module('starter')
        .controller('listCtrl', listCtrl);

    function listCtrl ($scope, $ionicModal, $rootScope, $state, $ionicLoading, config, apiRequesterService, headerTitleService) {

        $scope.$on('$stateChangeSuccess', function() {
            $ionicLoading.show(config.loading);
            // set headerTitle
            if ($state.current.name == 'list') {
                $scope.headerTitle = $rootScope.selected_pref_name;
                headerTitleService.setHeaderName($scope.headerTitle);
            }
            $scope.subTitle    = $rootScope.selected_city_name == '' ? $rootScope.selected_pref_name :  $rootScope.selected_city_name;
            $scope.is_shop = false;
            $scope.shops       = [];
            apiRequesterService.checkConnection().then(function(res){
                $scope.shops       = [];
                $rootScope.connected = 'connected';
                // get shop lists
                apiRequesterService.getShops($rootScope.list_condition).then(function(res) {
                    $ionicLoading.hide();
                    $scope.is_shop = true;
                    if (res.data.length == 0) {
                        $scope.is_shop = false;
                    }
                    angular.forEach(res.data, function (v, k) {
                        $scope.shops.push(v);
                    });
                }, function() {
                    $ionicLoading.hide();
                });
            },function(res){
                $ionicLoading.hide();
                $scope.err = false;
                $scope.errors = undefined;
                $scope.is_shop = false;
                $rootScope.connected = 'noConnection';
            });
        });
        // Go to map and save shopId selected
        $scope.goMap = function(data) {
            $rootScope.ShopId = data.shop_id;
            $state.go('map', {shop_params:data});
        }
    }
})();
