/*
 * ShopListCtrl
 *
 * responsible for stamp rally information
 * view : shop-list.html
 */
(function() {
    'use strict';

    angular
        .module('starter')
        .controller('ShopListCtrl', ShopListCtrl);

    function ShopListCtrl($scope, $log, $rootScope, $state, $ionicLoading, apiRequesterService, errorFactory, Flash) {

        var limit  = 8;
        var page   = 0;
        var offset = 0;
        $scope.shops = [];
        $scope.visited_shop_ids = [];
        $scope.mst_stamp_rally = $rootScope.StampRally.PosMstStampRally;
        $scope.noMoreItemsAvailable = false;

        angular.forEach($rootScope.StampRally.PosAcquiredStamp, function(value) {
          $scope.visited_shop_ids.push(value.mst_shop_id);
        });

        $scope.loadMore = function() {
          apiRequesterService.checkConnection().then(function(res) {
            $scope.noMoreItemsAvailable = true;
            let shop_ids = $scope.visited_shop_ids.join();
            apiRequesterService.getStampRallyShops($rootScope.StampRally.PosMstStampRally.id, shop_ids, limit, offset).then(function(res) {
              if (res.data.length !== 0) {
                $scope.shops = $scope.shops.concat(res.data);
                $scope.noMoreItemsAvailable = false;
                offset += limit;
              } else {
                $scope.noMoreItemsAvailable = true;
              }
            }, function(err) {
              $scope.noMoreItemsAvailable = true;
              $ionicLoading.hide();
            }).finally(function (){
              $scope.$broadcast('scroll.infiniteScrollComplete');
            });
          },function(err){
            $rootScope.connected = 'noConnection';
            $scope.$broadcast('scroll.infiniteScrollComplete');
          });
        }

        // Go to map and save shopId selected
        $scope.goMap = function(data) {
            $rootScope.ShopId = data.shop_id;
            $state.go('map', {shop_params:data});
        }
    }
})();
