/*
 * SurveyHomeCtrl
 *
 * responsible for displaying order history email screen
 * view : questions.html
 */
(function() {
    'use strict';

    angular
        .module('starter')
        .controller('SurveyHomeCtrl', SurveyHomeCtrl);

    function SurveyHomeCtrl($scope,$ionicSlideBoxDelegate, $state, apiRequesterService, $rootScope, $ionicLoading, config) {
        $scope.Survey = {};
        $ionicLoading.show(config.loading);
        $scope.isConnected = true;
        $scope.answered_flag = false;
        $scope.answer_load = false;

        function getQuestions(is_redirect) {
            apiRequesterService.checkConnection().then(function(res){
                $rootScope.connected = 'connected';
                apiRequesterService.getSurveys().then(function(res) {
                    $rootScope.Questions = [];
                    $rootScope.Survey = {}
                    $scope.is_empty = false;
                    angular.forEach(res.data, function (value, key) {
                        angular.forEach(value.Survey.Question, function (v, k) {
                            let data = [];
                            data['content']     = v.content;
                            data['type']        = v.type;
                            data['id']          = v.id;
                            data['min_char']    = v.min_char == null ? 0 : v.min_char;
                            data['is_required'] = v.is_required;
                            data['Selections']  = v.Selection;
                            $rootScope.Questions.push(data);
                        });
                        $rootScope.Survey.start_date = value.Survey.start_date;
                        $rootScope.Survey.end_date = value.Survey.end_date;
                        $rootScope.Survey.id = value.Survey.id;

                    });
                    if (typeof $rootScope.Survey.id != 'undefined') {
                        apiRequesterService.getAnswers($rootScope.Survey.id,$rootScope.Auth.customer_id,$rootScope.Auth.access_token).then(function(res) {
                            // check if there is answer
                            if (typeof res.data.Answer == 'undefined') {
                                $scope.answered_flag = true;
                                $scope.answer_load = false;
                            } else {
                                $scope.answer_load = true;
                            }
                        });
                        apiRequesterService.selectRewardPoints(1).then(function(res) {
                            $scope.get_points = res.data.RewardPoint.point

                        });
                    } else {
                        $scope.is_empty = true;
                    }
                    $scope.Survey = $rootScope.Survey;
                    $ionicLoading.hide();

                    $scope.isConnected = true;
                    if (is_redirect != null) {
                        $state.go('surveys-questions');
                    }
                }, function(err) {
                    $scope.isConnected = false;
                    $ionicLoading.hide();
                });

                $ionicLoading.hide();

            },function(res){
                $scope.errors = undefined;
                $rootScope.connected = 'noConnection';
                $ionicLoading.hide();
                $scope.isConnected = false;
            });
        }
        $scope.$on('$stateChangeSuccess', function() {
            if ($state.current.url == '/surveys/home') {
                $scope.answered_flag = false;
                $scope.answer_load = false;
                getQuestions();
            }
        });

        $scope.goHome = function() {
            $scope.answered_flag = false;
            $scope.answer_load = false;
            $state.go('home');
        }

        $scope.next = function() {
            apiRequesterService.checkConnection().then(function(res){
                $rootScope.connected = 'connected';
                if ($scope.isConnected) {
                    getQuestions(true);
                }
            },function(res){
                $scope.isConnected    = false;
                $rootScope.connected = 'noConnection';
            });
        }
        if ($rootScope.connected == 'noConnection') {
          $scope.checkConnection = 'navigation--no-connection'; // move down side menu if no internet
        }
    }

})();
