/*
 * SurveyQuestionsCtrl
 *
 * responsible for displaying order history email screen
 * view : questions.html
 */
(function() {
    'use strict';

    angular
        .module('starter')
        .controller('SurveyQuestionsCtrl', SurveyQuestionsCtrl);

    function SurveyQuestionsCtrl($scope, $state, $stateParams, $ionicSlideBoxDelegate, apiRequesterService, $rootScope, $ionicLoading, config, $ionicModal, $ionicScrollDelegate, $timeout) {
        // Default Data
        $scope.show_slide                   = false;
        $scope.data                         = {};
        $scope.data.questions               = $rootScope.Questions;
        $scope.data.page_num                = 1;
        $scope.data.total_question          = $scope.data.questions.length;
        $scope.data.multi_select            = [];
        $scope.data.select                  = [];
        $scope.data.text_area               = [];
        $scope.errors                       = [];
        $scope.isClickable                  = [];
        $scope.isClickable[0]               = true
        $scope.answer_contanier             = [];
        $scope.senddata                     = {};
        $scope.senddata.Answer              = {}
        $scope.senddata.Answer.survey_id    = $rootScope.Survey.id;
        $scope.senddata.Answer.customer_id  = $rootScope.Customer.customer_id;
        $scope.senddata.Answer.AnswerDetail = [];
        $scope.saving = false;
        // Disable slide for ion-slide
        $scope.disableSwipe = function() {
           $ionicSlideBoxDelegate.enableSlide(false);
        };
        // Function for enable or disable of paging in header
        var disableEnablePage = function(is_enable,page_start, page_size) {
            for (var i = page_start; i < page_size; i++) {
                $scope.isClickable[i] = is_enable;
            }
        }

        // Function for default setting
        var removeAllSurvey = function() {
            $scope.answer_contanier = [];
            $scope.data.select      = [];
            $scope.data.multi_select= [];
            $scope.data.text_area   = [];
            $scope.data.page_num    = 1;
        }
        // Modal Settings
        $ionicModal.fromTemplateUrl('js/ctrls/layouts/common/review-point-modal.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function(modal) {
            $scope.modal = modal;
        });
        // Modal Actions
        $scope.openModal = function(point) {
            $scope.point = point;
            $scope.modal.show();
        };

        $scope.closeModal = function() {
            $scope.modal.hide();
        };

        $scope.$on('modal.hidden', function() {
            removeAllSurvey();
        });
        $scope.goHome = function() {
            removeAllSurvey();
            $scope.errors         = [];
            $scope.isClickable    = [];
            $scope.isClickable[0] = true
            $scope.togglePage(1);
            $('.survey-questions__icon').removeClass('survey-questions__icon--checked');
            $state.go('surveys', {}, {reload: true}); //second parameter is for $stateParams
        }
        // Multi Select Listener for disable and enable of pages to prevent skipping page
        $scope.multiListener = function(value) {
            let no_error = true;
            let page_index = value+1;
            if (typeof $scope.data.multi_select[value] == 'undefined') {
                no_error = false;
            } else if ($scope.data.multi_select[value].length != 0) {
                var no_false_flag = false;
                angular.forEach($scope.data.multi_select[value], function (v, k) {
                    if(v == true) {
                        no_false_flag = true;
                        return;
                    }
                });
                if (no_false_flag == false) {
                    no_error = false;
                    disableEnablePage(false,0,$scope.answer_contanier.length);
                }
            } else {
                disableEnablePage(true,page_index,$scope.answer_contanier.length);
            }
        }
        $scope.content_ids = [];
        $scope.clear = function(key, id) {
            $scope.data.select[key] = null;
            $scope.content_ids[key] = id;
        }

        $scope.nextPage = function(type, value, primary_key, final, skip, is_required) {
            final = final != null ? true : false;
            skip  = skip  != null ? true : false;
            is_required  = is_required  != null ? is_required : 1;
            let no_error = true;
            let page_index = value+1;
            $scope.errors[value] = '';

            if (type == 1) {

                if (typeof $scope.data.select[value] == 'undefined' || $scope.data.select[value] == null) {

                    if (skip == true) {
                        $scope.answer_contanier[primary_key] = {is_form : true , value : null, selection_id : null};
                    } else {
                        if ((final == false) || final && is_required == 1) {
                            $scope.errors[value] = '必須入力です。';
                            no_error = false;
                            $scope.isClickable[page_index] = false;
                        } else {
                            $scope.answer_contanier[primary_key] = {is_form : true , value : null, selection_id : null};
                        }
                    }
                } else {
                    if (typeof $scope.data.select[value] == 'object') {
                        $scope.answer_contanier[primary_key] = {is_form : true , value : $scope.data.select[value][value], selection_id : $scope.content_ids[value]};
                    } else {
                        $scope.answer_contanier[primary_key] = {is_form : false , value : $scope.data.select[value]};
                    }

                }

            } else if (type == 2) {
                if (skip == true) {
                    $scope.answer_contanier[primary_key] = {null:true};
                } else if (typeof $scope.data.multi_select[value] == 'undefined') {
                    if (final && is_required == 1) {
                        $scope.errors[value] = '必須入力です。';
                        no_error = false;
                        $scope.isClickable[page_index] = false;
                    } else if (final == false) {
                        $scope.errors[value] = '必須入力です。';
                        no_error = false;
                        $scope.isClickable[page_index] = false;
                    } else {
                        $scope.answer_contanier[primary_key] = {null:true};
                    }

                } else if ($scope.data.multi_select[value].length != 0) {
                    var no_false_flag = false;
                    angular.forEach($scope.data.multi_select[value], function (v, k) {
                        if(v == true || typeof v == 'string' && v != '') {
                            no_false_flag = true;
                            return;
                        }
                    });
                    if (no_false_flag == false) {
                        $scope.errors[value] = '必須入力です。';
                        no_error = false;
                        $scope.isClickable[page_index] = false;
                    } else {
                        $scope.answer_contanier[primary_key] = $scope.data.multi_select[value];
                    }
                } else {
                    $scope.answer_contanier[primary_key] = $scope.data.multi_select[value];
                }

            } else if (type == 3) {
                $scope.answer_contanier[primary_key] = $scope.data.text_area[value];
                if (skip == true) {
                    $scope.answer_contanier[primary_key] = null;
                } else if (typeof $scope.data.text_area[value] == 'undefined' || $scope.data.text_area[value] == '') {
                    if ((final == false) || final && is_required == 1) {
                        $scope.errors[value] = '必須入力です。';
                        no_error = false;
                        $scope.isClickable[page_index] = false;
                    } else {
                        $scope.answer_contanier[primary_key] = null;
                    }
                } else if ($scope.data.text_area[value] != '' && $scope.data.text_area[value].length < parseInt($scope.data.questions[value].min_char) ) {
                    $scope.errors[value] = $scope.data.questions[value].min_char + '文字以上で入力してください。';
                    no_error = false;
                    $scope.isClickable[page_index] = false;
                }
            }

            if (final && no_error) {
                $scope.saving = true;
                $ionicLoading.show(config.loading);
                // sending api
                angular.forEach($scope.answer_contanier, function (value, key) {
                    let to_push = {};
                    to_push.question_id = key;
                    if (value == null) {
                        to_push.selection_id = null;
                        to_push.content = null;
                        $scope.senddata.Answer.AnswerDetail.push(to_push);
                    } else if (typeof value === 'object' && typeof value.is_form != 'undefined' ) {

                        if (value.is_form == false) {
                            to_push.selection_id = value.value;
                        } else {
                            to_push.selection_id = value.selection_id;
                            to_push.content = value.value;
                        }

                        $scope.senddata.Answer.AnswerDetail.push(to_push);
                    } else if (typeof value === 'object') {
                        angular.forEach(value, function(v,k) {
                            if (v == true || typeof v == 'string') {
                                let to_push_multi = {};
                                to_push_multi.question_id = key;
                                to_push_multi.selection_id = k;
                                if (typeof v == 'string') {
                                    to_push_multi.content = v;
                                }
                                $scope.senddata.Answer.AnswerDetail.push(to_push_multi);
                            }
                        });
                    } else if (typeof value === 'string') {
                        to_push.content = value;
                        $scope.senddata.Answer.AnswerDetail.push(to_push);
                    }

                });
                apiRequesterService.checkConnection().then(function(res){
                    $rootScope.connected = 'connected';
                    apiRequesterService.selectRewardPoints(1).then(function(res) {
                        let point = res.data.RewardPoint.point
                        // register answers
                        apiRequesterService.registerSurvey($rootScope.Customer, $rootScope.Auth, $scope.senddata).then(function(res) {
                            // register point
                            let survey_id = res.data.Answer.answer_id;
                            apiRequesterService.registerPoint($rootScope.Customer, $rootScope.Auth, survey_id,1,point).then(function(res) {
                                disableEnablePage(true,0,$scope.answer_contanier.length);
                                $ionicSlideBoxDelegate.slide(0);
                                removeAllSurvey();
                                $scope.openModal(point);
                                $state.go('home');
                                $ionicLoading.hide();
                                $scope.saving = false;
                            }, function(err) {
                                $scope.errors[value] = err;
                                $ionicLoading.hide();
                                $scope.saving = false;
                            });

                        }, function(err) {
                            $scope.errors[value] = err;
                            $ionicLoading.hide();
                            $scope.saving = false;
                        });

                    }, function(err) {
                        $scope.errors[value] = err;
                    });

                },function(res){
                    $scope.errors[value] = '';
                    $rootScope.connected = 'noConnection';
                    $ionicLoading.hide();
                    $scope.saving = false;
                });
            }

            if (no_error && final == false) {
                $scope.data.page_num = $scope.data.page_num + 1;
                $scope.isClickable[page_index] = true;
                $ionicSlideBoxDelegate.slide($scope.data.page_num - 1);
            }
            $ionicScrollDelegate.scrollTop();
        };

        $scope.removeLoading = function() {
          $ionicLoading.show(config.loading);
          $timeout(function() {
            $ionicLoading.hide();
          }, 100);
        }

        $scope.togglePage = function(pageNumber) {
            $ionicLoading.show(config.loading);
            $scope.data.page_num = pageNumber;
            $ionicSlideBoxDelegate.slide(pageNumber-1);
            $ionicScrollDelegate.scrollTop();
        }

        $scope.toggle = function(id){
            if($('#js-'+id).hasClass('survey-questions__icon--checked') == true ) {
                $('#js-'+id).removeClass('survey-questions__icon--checked');
            }else {
                $('#js-'+id).addClass('survey-questions__icon--checked');
            }
        }

        if ($rootScope.connected == 'noConnection') {
          $scope.checkConnection = 'navigation--no-connection'; // move down side menu if no internet
        }
    }

})();
