RiracleApp.controller("RiracleHeader",function($rootScope, $ionicHistory, $scope, $state, $ionicPopup, headerTitleService) {

  $scope.appState = $state;
  $scope.appChanged = "";
  $scope.headerTitle = "";

  $rootScope.$on('$stateChangeStart', function(event, toState, toParams, fromState, fromParams){
      $scope.appChanged = toState;
  });

  $scope.$watch(function() { return headerTitleService.getHeaderName(); }, function(newTitle) {
    $scope.headerTitle = newTitle;
  }, true);

  $scope.showMenu = function () {
    if ($rootScope.showBackButton) {
      $ionicHistory.goBack();
      $rootScope.showBackButton = false;
        $('.header__menu').toggleClass('header__menu--back');
    } else {
        $('.navigation').toggleClass('navigation--open');
        $('.header__menu').toggleClass('header__menu--close');
    }

    $('span.close-clk').click();
  };

  function showPopup() {
    var alertPopup = $ionicPopup.alert({
      title: 'ご利用上の注意',
      template: 'この機能のご利用にはログインが必要です。',
      buttons: [{text:'閉じる', type: 'button--cancel'}]
    });
  }

  $scope.goMyPage = function() {
    if (typeof $rootScope.Customer != 'undefined' && $rootScope.Customer != null) {
      $ionicHistory.nextViewOptions({
          disableAnimate: true
      });
      $state.go('mypage');
    } else {
      if ($state.current.name == 'login'){
        showPopup();
      } else {
        $ionicHistory.nextViewOptions({
            disableAnimate: true
        });
        $state.go('login');
      }
    }
  }

})
.directive('riracleHeader', function($compile) {
  return {
    restrict: 'E',
    controller: 'RiracleHeader',
    controllerAs: 'ctrl',
    scope: {},
    templateUrl: 'js/ctrls/layouts/common/header.html',
  };
});
